#ifndef __AVL_H
#define __AVL_H

typedef void* tipo_info;


#include "abb.h"


int member (abb *a, tipo_info k, func_ptr func, ...);
void RotacionaEsquerda (abb *t, celula_pt p);
void RotacionaDireita (abb *t, celula_pt p);
void balance (abb *a, celula_pt q);
void insere_avl (abb *a, tipo_info p, func_ptr func, ...);
void delete_avl (abb *a, tipo_info k, func_ptr func, ...);
void delete_cel_avl (abb *a, celula_pt q);
int altura (celula_pt p);

tipo_info before_avl (abb *a, tipo_info k, func_ptr func, ...);
tipo_info after_avl (abb *a, tipo_info k, func_ptr func, ...);


#endif
