#ifndef __ABB_H
#define __ABB_H


typedef struct cel {
  tipo_info info;
  struct cel *esq, *dir, *pai;
} celula, *celula_pt;


typedef tipo_info *tipo_info_ap;

typedef struct {
  celula_pt raiz, livre;
} abb;


typedef int (* func_ptr)();


#define MAX_PARAM 5


celula_pt nova_celula (abb *t);
void libera_celula (abb *t, celula_pt p);
void inicializa_abb (abb *t);
celula_pt busca_abb (abb *t, tipo_info k, func_ptr func, va_list *ptr);
celula_pt insere_abb (abb *t, tipo_info x, func_ptr func, va_list *ptr);
celula_pt minimo (celula_pt r);
int delete_abb (abb *t, tipo_info k, func_ptr func, va_list *ptr);
int delete_cel_abb (abb *t, celula_pt q);

tipo_info before_abb (abb *a, tipo_info k, func_ptr func, va_list *ptr);
tipo_info after_abb (abb *a, tipo_info k, func_ptr func, va_list *ptr);



#endif
